/* $Id: test_generic_addr.c,v 1.2 2002/09/18 09:08:54 bortzmeyer Exp $ */

#include <stdio.h>
#include "generic_addr.h"

#define PRINT_TEXT   printf ("The text form is %s\n", address_to_text (gaddr))

int
main (int argc, char **argv)
{
  char *textaddress, *textaddress2;
  generic_addr gaddr, gaddr2;
  if (argc < 3)
    {
      printf ("Usage: %s address address\n", argv[0]);
      return 1;
    }
  textaddress = argv[1];
  textaddress2 = argv[2];
  gaddr = text_to_address (textaddress);
  gaddr2 = text_to_address (textaddress2);
  if (IS_IPV6 (gaddr))
    {
      printf ("%s is a proper IPv6 address. ", textaddress);
      PRINT_TEXT;
    }
  else if (IS_IPV4 (gaddr))
    {
      printf ("%s is a proper IPv4 address. ", textaddress);
      PRINT_TEXT;
    }
  else if (IS_UNSPEC (gaddr))
    {
      printf ("%s is NOT a proper IP (v4 or v6) address.\n", textaddress);
      return 1;
    }
  else
    {
      printf ("%s is a proper address of an unknown type.\n", textaddress);
      return 1;
    }
  /* TODO: test gaddr2, too! */
  if (are_equal (gaddr, gaddr2))
    {
      printf ("The two addresses are equal\n");
    }
  else
    {
      printf ("The two addresses are different\n");
      if (is_lt (gaddr, gaddr2))
	printf ("The first is smaller\n");
      else
	printf ("The first is larger\n");
      if (is_gt (gaddr, gaddr2))
	printf ("The first is larger\n");
      else
	printf ("The first is smaller\n");
    }
  return 0;
}
